diff --git a/gnu/local.mk b/gnu/local.mk
index 186d82a8ab..e07b23b179 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -1201,7 +1201,6 @@ dist_patch_DATA =						\
   %D%/packages/patches/gdm-remove-hardcoded-xwayland-path.patch	\
   %D%/packages/patches/gdm-wayland-session-wrapper-from-env.patch	\
   %D%/packages/patches/gdm-pass-gdk-pixbuf-loader-env.patch	\
-  %D%/packages/patches/geeqie-clutter.patch			\
   %D%/packages/patches/gemmi-fix-pegtl-usage.patch		\
   %D%/packages/patches/gemmi-fix-sajson-types.patch		\
   %D%/packages/patches/genimage-mke2fs-test.patch		\
diff --git a/gnu/packages/image-viewers.scm b/gnu/packages/image-viewers.scm
index 0758cf5b27..470ae08a9b 100644
--- a/gnu/packages/image-viewers.scm
+++ b/gnu/packages/image-viewers.scm
@@ -24,7 +24,7 @@
 ;;; Copyright © 2021 Zheng Junjie <873216071@qq.com>
 ;;; Copyright © 2021 dissent <disseminatedissent@protonmail.com>
 ;;; Copyright © 2022 Michael Rohleder <mike@rohleder.de>
-;;; Copyright © 2022 Maxim Cournoyer <maxim.cournoyer@gmail.com>
+;;; Copyright © 2022, 2023 Maxim Cournoyer <maxim.cournoyer@gmail.com>
 ;;; Copyright © 2022 Tomasz Jeneralczyk <tj@schwi.pl>
 ;;; Copyright © 2022 Cairn <cairn@pm.me>
 ;;;
@@ -101,6 +101,7 @@ (define-module (gnu packages image-viewers)
   #:use-module (gnu packages upnp)
   #:use-module (gnu packages version-control)
   #:use-module (gnu packages video)
+  #:use-module (gnu packages vim)
   #:use-module (gnu packages web)
   #:use-module (gnu packages xdisorg)
   #:use-module (gnu packages xml)
@@ -231,7 +232,7 @@ (define-public feh
 (define-public geeqie
   (package
     (name "geeqie")
-    (version "1.6")
+    (version "2.0.1")
     (source (origin
               (method git-fetch)
               (uri (git-reference
@@ -239,43 +240,20 @@ (define-public geeqie
                     (commit (string-append "v" version))))
               (sha256
                (base32
-                "1i9yd8lddp6b9s9vjjjzbpqj4bvwidxc6kiba6vdrk7dda5akyky"))
-              (file-name (git-file-name name version))
-              (patches (search-patches "geeqie-clutter.patch"))))
-    (build-system gnu-build-system)
-    (arguments
-     ;; Enable support for a "map" pane using GPS data.
-     `(#:configure-flags '("CFLAGS=-O2 -g -fcommon"
-                           "--enable-map"
-                           "--enable-gtk3")
-       #:phases (modify-phases %standard-phases
-                  (add-after 'unpack 'correctly-locate-aux-scripts
-                    ;; The git checkout has symlinks under the auxdir
-                    ;; directory pointing to /usr/share/automake-1.16/depcomp
-                    ;; and /usr/share/automake-1.16/install-sh, which causes
-                    ;; the configure phase to fail (see:
-                    ;; https://github.com/BestImageViewer/geeqie/issues/936).
-                    (lambda* (#:key inputs #:allow-other-keys)
-                      (let ((automake (assoc-ref inputs "automake")))
-                        (delete-file "auxdir/depcomp")
-                        (symlink (car (find-files automake "depcomp"))
-                                 "auxdir/depcomp")
-                        (delete-file "auxdir/install-sh")
-                        (symlink (car (find-files automake "install-sh"))
-                                 "auxdir/install-sh")))))))
+                "199s0f3khnycr5vhk2ww3xnnasz7dzwxdl89pxjadq6rpgprfqyh"))
+              (file-name (git-file-name name version))))
+    (build-system meson-build-system)
     (inputs
-     (list clutter
-           libchamplain
+     (list exiv2
+           gtk+
            lcms
-           exiv2
-           libpng
-           gtk+))
+           libchamplain
+           libpng))
     (native-inputs
-     (list autoconf
-           automake
-           `(,glib "bin") ; glib-gettextize
+     (list `(,glib "bin") ; glib-gettextize
            intltool
-           pkg-config))
+           pkg-config
+           xxd))
     (home-page "https://www.geeqie.org/")
     (synopsis "Lightweight GTK+ based image viewer")
     (description
diff --git a/gnu/packages/patches/geeqie-clutter.patch b/gnu/packages/patches/geeqie-clutter.patch
deleted file mode 100644
index ab7cc957d8..0000000000
--- a/gnu/packages/patches/geeqie-clutter.patch
+++ /dev/null
@@ -1,35 +0,0 @@
-From c99084ac5fc2fb854ff8e8abd4bd3298fb08fb43 Mon Sep 17 00:00:00 2001
-From: Colin Clark <colin.clark@cclark.uk>
-Date: Sat, 9 Jan 2021 11:35:41 +0000
-Subject: [PATCH] Fix #829: segfault with clutter-gtk
-
-https://github.com/BestImageViewer/geeqie/issues/829
-
-This fix might cause other problems which might be cured by calling:
-LIBGL_ALWAYS_INDIRECT=1 geeqie
-
-or, worst case:
-geeqie --disable-clutter
----
- src/main.c | 5 -----
- 1 file changed, 5 deletions(-)
-
-diff --git a/src/main.c b/src/main.c
-index f497240d..4af654fe 100644
---- a/src/main.c
-+++ b/src/main.c
-@@ -904,11 +904,6 @@ gint main(gint argc, gchar *argv[])
- #ifdef HAVE_GTHREAD
- #if !GLIB_CHECK_VERSION(2,32,0)
- 	g_thread_init(NULL);
--#endif
--#ifdef HAVE_CLUTTER
--/* FIXME: see below */
--	putenv("LIBGL_ALWAYS_INDIRECT=1");
--	XInitThreads();
- #endif
- 	gdk_threads_init();
- 	gdk_threads_enter();
--- 
-2.34.0
-