diff --git a/gnu/local.mk b/gnu/local.mk
index 18e8235140..50d65a3dba 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -741,6 +741,7 @@ GNU_SYSTEM_MODULES =				\
   %D%/system/images/pine64.scm			\
   %D%/system/images/pinebook-pro.scm		\
   %D%/system/images/rock64.scm			\
+  %D%/system/images/unmatched.scm		\
   %D%/system/images/wsl2.scm			\
 						\
   %D%/machine.scm				\
diff --git a/gnu/system/images/unmatched.scm b/gnu/system/images/unmatched.scm
new file mode 100644
index 0000000000..06d8d876d1
--- /dev/null
+++ b/gnu/system/images/unmatched.scm
@@ -0,0 +1,94 @@
+;;; GNU Guix --- Functional package management for GNU
+;;; Copyright © 2023 Efraim Flashner <efraim@flashner.co.il>
+;;;
+;;; This file is part of GNU Guix.
+;;;
+;;; GNU Guix is free software; you can redistribute it and/or modify it
+;;; under the terms of the GNU General Public License as published by
+;;; the Free Software Foundation; either version 3 of the License, or (at
+;;; your option) any later version.
+;;;
+;;; GNU Guix is distributed in the hope that it will be useful, but
+;;; WITHOUT ANY WARRANTY; without even the implied warranty of
+;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;;; GNU General Public License for more details.
+;;;
+;;; You should have received a copy of the GNU General Public License
+;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
+
+(define-module (gnu system images unmatched)
+  #:use-module (gnu bootloader)
+  #:use-module (gnu bootloader u-boot)
+  #:use-module (gnu image)
+  #:use-module (gnu packages linux)
+  #:use-module (gnu services)
+  #:use-module (gnu services base)
+  #:use-module (gnu services networking)
+  #:use-module (gnu system)
+  #:use-module (gnu system file-systems)
+  #:use-module (gnu system image)
+  #:use-module (guix platforms riscv)
+  #:use-module (srfi srfi-26)
+  #:export (unmatched-barebones-os
+            unmatched-image-type
+            unmatched-barebones-raw-image))
+
+(define unmatched-barebones-os
+  (operating-system
+    (host-name "unmatched")
+    (timezone "Asia/Jerusalem")
+    (locale "en_US.utf8")
+    (bootloader (bootloader-configuration
+                 (bootloader u-boot-sifive-unmatched-bootloader)
+                 (targets '("/dev/vda"))))
+    (initrd-modules '())
+    (kernel linux-libre-riscv64-generic)
+    (file-systems (cons (file-system
+                          (device (file-system-label "my-root"))
+                          (mount-point "/")
+                          (type "ext4"))
+                        %base-file-systems))
+    (services
+      (append (list (service agetty-service-type
+                             (agetty-configuration
+                              (extra-options '("-L")) ; no carrier detect
+                              (baud-rate "115200")
+                              (term "vt100")
+                              (tty "ttySIF0")))
+                    (service dhcp-client-service-type))
+              %base-services))))
+
+(define unmatched-disk-image
+  (image-without-os
+   (format 'disk-image)
+   (partition-table-type 'gpt)
+   ;; https://source.denx.de/u-boot/u-boot/-/blob/master/doc/board/sifive/unmatched.rst
+   (partitions (list
+                (partition
+                 (size (* 1 (expt 2 20)))
+                 (label "spl")
+                 (offset (* 34 512))
+                 (file-system "unformatted")
+                 (uuid (uuid "5b193300-fc78-40cd-8002-e86c45580b47"))) ; HiFive FSBL
+                (partition
+                 (size (* 4 (expt 2 20)))
+                 (label "uboot")
+                 (offset (* 2082 512))
+                 (file-system "unformatted")
+                 (uuid (uuid "2e54b353-1271-4842-806f-e436d6af6985"))) ; HiFive BBL
+                root-partition))))
+
+(define unmatched-image-type
+  (image-type
+   (name 'unmatched-raw)
+   (constructor (cut image-with-os unmatched-disk-image <>))))
+
+(define unmatched-barebones-raw-image
+  (image
+   (inherit
+    (os+platform->image unmatched-barebones-os riscv64-linux
+                        #:type unmatched-image-type))
+   (name 'unmatched-barebones-raw-image)))
+
+;; Return the default image.
+unmatched-barebones-raw-image